version: '3'

services:
# Router

  ## router 01
  router01:
    image: mongo:4.2
    container_name: router-01
    command: |
      mongos --port 27017 --configdb rs-config-server/configsvr01:27017,configsvr02:27017,configsvr03:27017 --bind_ip_all
    ports:
      - 27117:27017
    volumes:
      - ./scripts:/scripts

  ## router 02
  router02:
    image: mongo:4.2
    container_name: router-02
    command: |
      mongos --port 27017 --configdb rs-config-server/configsvr01:27017,configsvr02:27017,configsvr03:27017 --bind_ip_all
    volumes:
      - ./scripts:/scripts
    ports:
      - 27118:27017
    links:
      - router01

# Config Servers

  ## Config server 01
  configsvr01:
    image: mongo:4.2
    container_name: mongo-config-01 
    command: |
      mongod --port 27017 --configsvr --replSet rs-config-server
    volumes:
      - ./scripts:/scripts 
    ports:
      - 27119:27017
    links:
      - shard01-a
      - shard02-a
      - shard03-a

  ## Config server 02
  configsvr02:
    image: mongo:4.2
    container_name: mongo-config-02 
    command: |
      mongod --port 27017 --configsvr --replSet rs-config-server
    volumes:
      - ./scripts:/scripts
    ports:
      - 27120:27017
    links:
      - configsvr01

  ## Config server 03
  configsvr03:
    image: mongo:4.2
    container_name: mongo-config-03 
    command: |
      mongod --port 27017 --configsvr --replSet rs-config-server
    volumes:
      - ./scripts:/scripts
    ports:
      - 27121:27017
    links:
      - configsvr02

# Shards

  ## Shards 01   
  shard01-a:
    image: mongo:4.2
    container_name: shard-01-node-a
    command: |
      mongod --port 27017 --shardsvr --replSet rs-shard-01
    volumes:
      - ./scripts:/scripts
    ports:
      - 27122:27017
    links:
      - shard01-b
      - shard01-arb
  shard01-b:
    image: mongo:4.2
    container_name: shard-01-node-b
    command: |
      mongod --port 27017 --shardsvr --replSet rs-shard-01
    volumes:
      - ./scripts:/scripts
    ports:
      - 27123:27017
  shard01-arb:
    image: mongo:4.2
    container_name: shard-01-arbiter
    command: |
      mongod --port 27017 --shardsvr --replSet rs-shard-01
    volumes:
      - ./scripts:/scripts
    ports:
      - 27124:27017

  ## Shards 02
  shard02-a:
    image: mongo:4.2
    container_name: shard-02-node-a
    command: |
      mongod --port 27017 --shardsvr --replSet rs-shard-02
    volumes:
      - ./scripts:/scripts
    ports:
      - 27125:27017
    links:
      - shard02-b
      - shard02-arb
  shard02-b:
    image: mongo:4.2
    container_name: shard-02-node-b
    command: |
      mongod --port 27017 --shardsvr --replSet rs-shard-02
    volumes:
      - ./scripts:/scripts
    ports:
      - 27126:27017
  shard02-arb:
    image: mongo:4.2
    container_name: shard-02-arbiter
    command: |
      mongod --port 27017 --shardsvr --replSet rs-shard-02
    volumes:
      - ./scripts:/scripts
    ports:
      - 27127:27017

  ## Shards 03
  shard03-a:
    image: mongo:4.2
    container_name: shard-03-node-a
    command: |
      mongod --port 27017 --shardsvr --replSet rs-shard-03
    volumes:
      - ./scripts:/scripts
    ports:
      - 27128:27017
    links:
      - shard03-b
      - shard03-arb
  shard03-b:
    image: mongo:4.2
    container_name: shard-03-node-b
    command: |
      mongod --port 27017 --shardsvr --replSet rs-shard-03
    volumes:
      - ./scripts:/scripts
    ports:
      - 27129:27017
  shard03-arb:
    image: mongo:4.2
    container_name: shard-03-arbiter
    command: |
      mongod --port 27017 --shardsvr --replSet rs-shard-03
    volumes:
      - ./scripts:/scripts
    ports:
      - 27130:27017

networks:
  default:
    name: humor_network
    external: true







